Package com.independentsoft.graph.planner

# Class PlannerTask

java.lang.Object
com.independentsoft.graph.planner.PlannerTask

All Implemented Interfaces:
  `ICreatable`, `IUpdatable`

public class PlannerTask extends Object implements ICreatable, IUpdatable
Represents a task in Microsoft Planner.

A PlannerTask is contained in a plan and can be assigned to users and organized into buckets. It tracks progress through a percent-complete value and exposes scheduling information such as start and due dates, along with checklist and reference counts.

Example usage:

     // Create a new planner task
     PlannerTask task = new PlannerTask();
     task.setPlanId(planId);
     task.setBucketId(bucketId);
     task.setTitle("Design review");

Since:
  1.0
See Also:
  plannerTask resource type

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlannerTask()`
  `PlannerTask​(JsonObject jsonObject)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getActiveChecklistItemCount()`
  `String`
  `getAssigneePriority()`
  `String`
  `getBucketId()`
  `int`
  `getChecklistItemCount()`
  `IdentitySet`
  `getCompletedBy()`
  `Date`
  `getCompletedDateTime()`
  `String`
  `getConversationThreadId()`
  `IdentitySet`
  `getCreatedBy()`
  `Date`
  `getCreatedDateTime()`
  `Date`
  `getDueDateTime()`
  `String`
  `getEtag()`
  `String`
  `getId()`
  `String`
  `getOrderHint()`
  `int`
  `getPercentComplete()`
  `String`
  `getPlanId()`
  `String`
  `getPreviewType()`
  `int`
  `getPriority()`
  `int`
  `getReferenceCount()`
  `Date`
  `getStartDateTime()`
  `String`
  `getTitle()`
  `boolean`
  `hasDescription()`
  `boolean`
  `isArchived()`
  `boolean`
  `isOnMyDay()`
  `void`
  `setAssigneePriority​(String assigneePriority)`
  `void`
  `setBucketId​(String bucketId)`
  `void`
  `setConversationThreadId​(String conversationThreadId)`
  `void`
  `setDueDateTime​(Date dueDateTime)`
  `void`
  `setId​(String id)`
  `void`
  `setOnMyDay​(boolean isOnMyDay)`
  `void`
  `setOrderHint​(String orderHint)`
  `void`
  `setPercentComplete​(int percentComplete)`
  `void`
  `setPlanId​(String planId)`
  `void`
  `setPreviewType​(String previewType)`
  `void`
  `setPriority​(int priority)`
  `void`
  `setStartDateTime​(Date startDateTime)`
  `void`
  `setTitle​(String title)`
  `String`
  `toCreateJson()`
  Converts this object to its JSON representation for creation.
  `String`
  `toString()`
  `String`
  `toUpdateJson()`
  Converts this object to its JSON representation for update.
  `String`
  `toUpdateJson​(List<String> propertyNames)`
  Converts this object to JSON for update with specific properties.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### PlannerTask

    public PlannerTask()

  - ### PlannerTask

    public PlannerTask​(JsonObject jsonObject)

- ## Method Details

  - ### toCreateJson

    public String toCreateJson()
    Description copied from interface: `ICreatable`
    Converts this object to its JSON representation for creation.

    This method generates a JSON string containing all properties needed to create a new instance of this resource in Microsoft Graph. Only properties appropriate for creation should be included (e.g., excluding read-only properties like ID, createdTime, etc.).

    Specified by:
      `toCreateJson` in interface `ICreatable`
    Returns:
      JSON string representation for creating this resource

  - ### toUpdateJson

    public String toUpdateJson()
    Description copied from interface: `IUpdatable`
    Converts this object to its JSON representation for update.

    This method generates a JSON string containing all modified properties that should be updated in Microsoft Graph. Only writeable properties with non-null values are typically included.

    Specified by:
      `toUpdateJson` in interface `IUpdatable`
    Returns:
      JSON string representation for updating this resource

  - ### toUpdateJson

    public String toUpdateJson​(List<String> propertyNames)
    Description copied from interface: `IUpdatable`
    Converts this object to JSON for update with specific properties.

    This method generates a JSON string containing only the specified properties. This enables partial updates where only certain fields need to be modified, reducing payload size and avoiding unintended changes to other properties.

    Specified by:
      `toUpdateJson` in interface `IUpdatable`
    Parameters:
      `propertyNames` - List of property names to include in the JSON. If null or empty, all modified properties are included.
    Returns:
      JSON string representation for updating specific properties

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getEtag

    public String getEtag()

  - ### getId

    public String getId()

  - ### setId

    public void setId​(String id)

  - ### getTitle

    public String getTitle()

  - ### setTitle

    public void setTitle​(String title)

  - ### getPlanId

    public String getPlanId()

  - ### setPlanId

    public void setPlanId​(String planId)

  - ### getBucketId

    public String getBucketId()

  - ### setBucketId

    public void setBucketId​(String bucketId)

  - ### getPercentComplete

    public int getPercentComplete()

  - ### setPercentComplete

    public void setPercentComplete​(int percentComplete)

  - ### getPriority

    public int getPriority()

  - ### setPriority

    public void setPriority​(int priority)

  - ### getOrderHint

    public String getOrderHint()

  - ### setOrderHint

    public void setOrderHint​(String orderHint)

  - ### getAssigneePriority

    public String getAssigneePriority()

  - ### setAssigneePriority

    public void setAssigneePriority​(String assigneePriority)

  - ### getStartDateTime

    public Date getStartDateTime()

  - ### setStartDateTime

    public void setStartDateTime​(Date startDateTime)

  - ### getDueDateTime

    public Date getDueDateTime()

  - ### setDueDateTime

    public void setDueDateTime​(Date dueDateTime)

  - ### getCompletedDateTime

    public Date getCompletedDateTime()

  - ### getCreatedDateTime

    public Date getCreatedDateTime()

  - ### getCreatedBy

    public IdentitySet getCreatedBy()

  - ### getCompletedBy

    public IdentitySet getCompletedBy()

  - ### hasDescription

    public boolean hasDescription()

  - ### getPreviewType

    public String getPreviewType()

  - ### setPreviewType

    public void setPreviewType​(String previewType)

  - ### getReferenceCount

    public int getReferenceCount()

  - ### getChecklistItemCount

    public int getChecklistItemCount()

  - ### getActiveChecklistItemCount

    public int getActiveChecklistItemCount()

  - ### getConversationThreadId

    public String getConversationThreadId()

  - ### setConversationThreadId

    public void setConversationThreadId​(String conversationThreadId)

  - ### isArchived

    public boolean isArchived()

  - ### isOnMyDay

    public boolean isOnMyDay()

  - ### setOnMyDay

    public void setOnMyDay​(boolean isOnMyDay)